<?php
/**
 * [Controller]BaseController：基底コントローラ
 * 全てのコントローラで継承すること
 *
 * abstract class : post()|get()
 * @link http://komaphp.k-akimoto-matsu.net/Manual#subtitle7 マニュアル@コントローラ
 * @author TakanoriMatsushige < http://k-akimoto-matsu.net/Inquiry >
 * @copyright k_akimoto_matsu. All Rights Reserved
 */
abstract class BaseController{
	/**
	 * Getメソッド（強制）画面表示
	 */
	abstract protected function get();

	/**
	 * Postメソッド（強制）POST送信
	 * Input::get({コントロール名})またはInput::all()でPOST値(FILES,REQUESTも)を取得可能
	 */
	abstract protected function post();

	//検索条件をリセット
	public function destroyListSession(){
		Session::destroy("UserList"); //ユーザ一覧の検索条件
		Session::destroy("ItemList");
	}

	public $properties = [];

	function __set($name,$value =null){
		$this->properties[$name] = $value;
	}
	function __get($name){
		return Html::hsp($this->properties[$name]);
	}

	//ログインしているかチェック
	function auth(){
		if((is_null(Session::get("login")) || !Session::get("login"))) return false;
		return true;
	}

}