<?php
/**
 * [Controller]InculdeController：Include処理コントローラ
 * 主に画像などの表示処理を行う（汎用コントローラ）
 *
 * @link http://komaphp.k-akimoto-matsu.net/Manual#subtitle14 マニュアル@Ajax
 * @author TakanoriMatsushige < http://k-akimoto-matsu.net/Inquiry >
 * @copyright k_akimoto_matsu. All Rights Reserved
 */
class IncludeController extends BaseController{
	protected $param = []; //viewに渡すパラメータ

	function get($ret = []){
		$t = null;
		if(Helper::ak("target", $ret["route"])){
			$t =  $ret["route"]["target"];
		}

		if(method_exists($this, $ret["route"]["func"])){
			$this->param["ret"] = $this->$ret["route"]["func"]($t);
		}else{
			$this->noimage();
		}
		return $this->param;
	}

	function post($ret = []){
		return $this->param["ret"] = null;
	}

	function thumb($t){
		if(!isset($t) || is_null($t)){
			return $this->noimage();
		}

		$r = explode(".",$t);

		$imgfunc = null;
		$imgtype = null;
		if(isset($r[1])){
			switch($r[1]){
				case "jpg":
				case "jpeg":
				case "JPG":
				case "JPEG":
					$imgfunc = "imagecreatefromjpeg";
					$imgtype = "jpeg";
					$imgf = "imagejpeg";
					break;
				case "gif":
				case "GIF":
					$imgfunc = "imagecreatefromgif";
					$imgtype = "gif";
					$imgf = "imagegif";
					break;
				case "png":
				case "PNG":
					$imgfunc = "imagecreatefrompng";
					$imgtype = "png";
					$imgf = "imagepng";
					break;
			}
		}

		$t = str_replace(Config::get("app","dir"),DS,$t);
		if(file_exists(__DIR__.DS."..".DS."storage".DS."img".DS.$t)){

			$im = $imgfunc(__DIR__.DS."..".DS."storage".DS."img".DS.$t);
			//元画像のサイズを取得
			list($img_w,$img_h) = getimagesize(__DIR__.DS."..".DS."storage".DS."img".DS.$t);

			$logosize = 50;

			$bgw = $logosize;
			$bgh = $logosize;
			if($img_w >= $logosize || $img_h >= $logosize){
				if($img_w >= $logosize && $img_h < $logosize){
					$bgw = $logosize;
					$bgh = round($img_h * ($logosize / $img_w));
				}
				if($img_w < $logosize && $img_h > $logosize){
					$bgh = $logosize;
					$bgw = round($img_w * ($logosize / $img_h));
				}
				if($img_w >= $logosize && $img_h >= $logosize && $img_w > $img_h){
					$bgw = $logosize;
					$bgh = round($img_h * ($logosize / $img_w));
				}
				if($img_w >= $logosize && $img_h >= $logosize && $img_w < $img_h){
					$bgh = $logosize;
					$bgw = round($img_w * ($logosize / $img_h));
				}
			}

			//背景画像
			$backimage = imagecreatetruecolor($bgw,$bgh);

			//背景画像に元画像をコピー
			imagecopyresampled($backimage,$im,0,0,0,0,$bgw,$bgh,$img_w,$img_h);

			header('Content-type: image/'.$imgtype.';');
			$imgf($backimage);
			exit;
		}else{
			$this->noimage();
		}
	}

	function image($t){
		if(!isset($t) || is_null($t)){
			return $this->noimage();exit;
		}
		$r = explode(".",$t);
		$imgfunc = null;
		$imgtype = null;
		if(isset($r[1])){
			switch($r[1]){
				case "jpg":
				case "jpeg":
				case "JPG":
				case "JPEG":
					$imgfunc = "imagecreatefromjpeg";
					$imgtype = "jpeg";
					$imgoutfunc = "imagejpeg";
					break;
				case "gif":
				case "GIF":
					$imgfunc = "imagecreatefromgif";
					$imgtype = "gif";
					$imgoutfunc = "imagegif";
					break;
				case "png":
				case "PNG":
					$imgfunc = "imagecreatefrompng";
					$imgtype = "png";
					$imgoutfunc = "imagepng";
					break;
			}
		}
		$t = str_replace(Config::get("app","dir"),DS,$t);

		if(file_exists(__DIR__.DS."..".DS."storage".DS."img".DS.$t)){
			$im = $imgfunc(__DIR__.DS."..".DS."storage".DS."img".DS.$t);

			if($imgtype == "png"){
				$x = imagesx($im);
				$y = imagesy($im);
				$resize = imagecreatetruecolor($x, $y);
				//ブレンドモードを無効にする
				imagealphablending($resize, false);
				//完全なアルファチャネル情報を保存するフラグをonにする
				imagesavealpha($resize, true);
				imagecopyresampled($resize, $im, 0, 0, 0, 0, $x, $y, $x, $y);
				header("Content-type: image/png;");
				imagepng($resize);
				exit;
			}
			header("Content-type: image/{$imgtype};");
			$imgoutfunc($im);
			exit;
			//画像無し
		}else{
			$this->noimage();
		}
	}

	private function noimage(){
		$im = imagecreate(100,100);
		$wh = imagecolorallocate($im,255,255,255);
		$bl = imagecolorallocate($im,0,0,0);
		imagerectangle($im, 0, 0,95, 95, $bl);
		imagettftext($im,8,0,10,20,$bl,__DIR__."/../storage/fonts/imagefonts.TTF","no image");
		header('Content-type: image/png;');
		imagepng($im);
		exit;
	}
}