<?php
/**
 * [Controller]auth/LoginController：ログイン処理コントローラ
 * ログイン画面の表示とログイン認証処理を行う
 */
class LoginController extends BaseController{
	protected $param = []; //viewに渡すパラメータ
	protected $title = 'ログイン';

	function get($ret = []){
		Session::destroy();
		Session_start();

		$this->param['title'] = $this->title;
		return $this->param;
	}

	function post($ret = []){
		$this->param['title'] = $this->title;

		$err = Validation::validate("Login");
		$this->param['loginerror'] = false;

		//エラーなければログインチェック
		if(count($err) == 0){
			$user = DbModel::read("User");
			$w = array(
				"login_id"=>Input::get-("login_id"),
				"password"=> hash(Config::get("app","hash_key"),$user->prefix."_".Input::get("password")),
			);

			$d = $user->getOneInfo($w);
			//認証結果
			if(count($d) == 0){
				$this->param['loginerror'] = true;
				$w = array(
					"login_id"=>Input::get("login_id"),
				);
				$d = $user->getOneInfo($w);
				//アカウントが存在する場合はロックカウント＋する
				if(count($d) > 0){
					if(($d["lockcnt"]+1) > Config::get("app","lockcnt")){
						$this->param['loginerror'] = null;
						$this->param['lockerror'] = true;
						$user->update("User_dummy",$w,$d);
						Log::set("Locked Login :LockError");
					}else{
						$d = array("lockcnt"=>$d["lockcnt"]+1);
						$user->update("User_dummy",$w,$d);
						Log::set("Locked LoginID:".Input::get("login_id")." Cnt:".($d["lockcnt"]+1));
					}
				}
			}else{
				//ロック中はログインさせない
				if($d["lockcnt"] >= Config::get("app","lockcnt")){
					Log::set("Locked Login :LockError");
					$this->param['lockerror'] = true;
				}else{
					$this->param['loginerror'] = false;
					Session::reg_id();

					Session::set("UserInfo",$d);
					Session::set("login",true);
					Session::set("last_action",time());

					//最終ログイン日時を更新
					$w = array("user_id"=>$d["user_id"]);
					$d = array("last_logindate"=>date("Y-m-d H:i:s"),"lockcnt"=>"0");//ログイン成功したら0に
					$user->update("User_dummy",$w,$d);
					Log::set("Login");

					Helper::redirect("Menu");
					exit(0);
				}
			}
		}else{

			$this->param['error'] = $err;
		}

		return $this->param;
	}
}