<?php
/**
 * [Core]Config：設定取得コントローラ
 * 指定に応じて設定ファイルより設定を取得する
 *
 * @link http://komaphp.k-akimoto-matsu.net/Reference#subtitle0 リファレンス@Core.Config
 * @author TakanoriMatsushige < http://k-akimoto-matsu.net/Inquiry >
 * @copyright k_akimoto_matsu. All Rights Reserved
 */
class Config{
	/**
	 * 設定ファイルの設定を返却
	 * 設定ファイルは fwapp/Config内にarrayで定義すること
	 * @param unknown $name 設定ファイル名
	 * @param unknown $setting 取得設定情報（「.」でつなぐ）
	 * @return NULL|unknown|NULL|unknown
	 */
	public static function get($name=null ,$setting=null){
		if(is_null($name) || $name == "") return null;

		$confFileName = __DIR__.DS."..".DS."Config".DS."{$name}.php";

		if(!file_exists($confFileName)){
			return null;
		}

		$conf = require $confFileName;
		if(is_null($setting) || $setting == ""){
			return $conf;
		}

		$confset = explode(".",$setting);

		$cnt = 0;
		$conff = null;
		foreach($confset as $k){
			if($cnt == 0){
				if(Helper::ak($k, $conf)){
					$conff = $conf[$k];
				}
			}else{
				if(Helper::ak($k, $conff)){
					$conff = $conff[$k];
				}else{
					$conff = null;
				}
			}
			$cnt++;
		}

		return $conff;

	}
}