<?php
/**
 * [Core]View：画面表示クラス
 * URL解析・ルーティング・コントローラ呼び出しからビュー呼び出しまでを行う
 *
 * @link http://komaphp.k-akimoto-matsu.net/Reference#subtitle0 リファレンス@Core.View
 * @author TakanoriMatsushige < http://k-akimoto-matsu.net/Inquiry >
 * @copyright k_akimoto_matsu. All Rights Reserved
 */
class View{

	/**
	 * メイン処理
	 * @return void|unknown
	 */
	public static function display(){
		Session::start();
		Session::destroy("DBCon");
		$url = Url::analysis();
		$router = require_once __DIR__.DS.'..'.DS.'route.php'; //ルーティング

		$mode = "web";

		//１つ目はコントローラー名
		if(count($url) == 0){
			$route = "index";
		}else{
			$route = $url[0];
		}
		if(!Helper::ak($route,$router)){
			$msg = "wrong access dont exists router:".$route;
			return require_once __DIR__.DS.'..'.DS.'View'.DS.'error.php';
		}
		$conName = $router[$route]["controller"];
		$cFName = $conName."Controller";

		require_once __DIR__.DS.'..'.DS.'Controller'.DS.'BaseController.php';
		if(!file_exists(__DIR__.DS.'..'.DS.'Controller'.DS.$cFName.'.php')){
			$msg = "wrong access".$cFName;
			return require_once __DIR__.DS.'..'.DS.'View'.DS.'error.php';

		}else{
			$ret = [];
			$ro = [];
			$pager = false;
			$ur = null;
			$ret['route_url'] = $route;
			$ret['router'] = $router[$route];
			if(Helper::ak('set', $router[$route])){
				$cnt = 1;
				foreach($url as $k=>$v){
						$v = Html::hsp($v);
					if($k == 0) continue; //１つ目はルータ名のため回避
					if(Helper::ak($k, $router[$route]['set'])){
						${$router[$route]['set'][$k]} = $v;
						$ret['route'][$router[$route]['set'][$k]] =  $v;
						$ur .= DS.$v;
					}else{
						$cnt++;
					}
				}
			}
			//ページャー導入するか否か
			//listtemplateを使うときのみ
			if(Helper::ak('pager',$router[$route])){
				$pager = $router[$route]['pager'];
			}

			//アクセス許可等々は認証ページ機能
			if($mode == Config::get("app","auth")){
				//Top以外では自動ログアウトありa
				if(!in_array($route,Config::get("app","no_login"))){
					if(!Config::get("app","debug")){
						$last_action_time = is_null(Session::get("last_action")) ? 0 : Session::get("last_action") ;

						if($last_action_time > 0){
							$no_action_time =  time() - $last_action_time;

							if(Config::get("app","auto_logout") < $no_action_time){
								Log::set("auto logout. ".number_format($no_action_time)."sec stay " );
								Helper::redirect("Login/at");
								return;
							}else{
								Session::set("last_action",time());
							}
						}
					}
					Session::set("last_action",time());
				}
				//ログイン必須機能以外はログインページへ強制リダイレクト
				if(!in_array($conName,Config::get("app","no_login")) and (is_null(Session::get("login")) || !Session::get("login"))){
					Helper::redirect("Login");
					return;
				}
			}

			require_once __DIR__.DS.'..'.DS.'Controller'.DS.str_replace("/",DS,$cFName).'.php';

			$cExp = explode("/",$conName);
			$rCon =null;
			$rCon = $cExp[(count($cExp)-1)]."Controller"; //コントローラ名決定

			if(!is_null($rCon) && class_exists($rCon)){
				$class = new $rCon;
				if($_SERVER['REQUEST_METHOD'] == 'POST'){
					$me = 'post';
				}else{
					$me = 'get';
				}
				$param = $class->$me($ret);

				if(Helper::ak('view',$ret['router'])){
					if(!file_exists(__DIR__.DS.'..'.DS.'View'.DS.$ret['router']['view'].'.php')){
						$msg = "no view";
						return require_once __DIR__.DS.'..'.DS.'View'.DS.'error.php';
					}else{

						if(Helper::ak("title", $param)){
							$title = $param['title'];
						}

						header("X-FRAME-OPTIONS:DENY");
						header("Cache-Control:no-cache,must-revalidate");
						header("Expires:".date("Y-m-d H:i:s",time() - (60*61)));
						header("Content-type: text/html;charset=UTF-8");

						$root = Config::get("app","httproot");
						$ow = Config::get("app","ownerweb");

						return require_once __DIR__.DS.'..'.DS.'View'.DS.$ret['router']['view'].'.php';
					}
				}
			}

			$msg = "wrong access";
			return require_once __DIR__.DS.'..'.DS.'View'.DS.'error.php';
		}
	}
}