<?php
/**
 * [Model]Item：商品モデル
 *
 * @link http://komaphp.k-akimoto-matsu.net/Manual#subtitle10 マニュアル@モデル
 */
class Item extends Model{
	/**
	 * コンストラクタ（tableとkeyの設定のため必須）
	 */
	public function __construct(){
		$this->table = "m_item";
		$this->key = "item_id";
	}
	/**
	 * IDからデータを取得
	 * @param unknown $id
	 * @return unknown[]
	 */
	public function getInfoByID($id = null){
		if(is_null($id)) return null;
		return $this->getByID($this->key,$id);
	}

	/**
	 * 検索条件、ソート順指定で一覧情報を取得
	 * @param array $w
	 * @param array $order
	 * @return unknown[]
	 */
	public function getList($w=[],$order = []){
		return $this->get($w,false,array_merge([$this->key=>0],$order));
	}

	/**
	 * 検索条件、ソート順指定で1件データを取得
	 * @param array $w
	 * @param array $order
	 * @return unknown[]
	 */
	public function getOneInfo($w=[],$order = []){
		return $this->get($w,true,$order);
	}

	/**
	 * 検索設定とソート指定で一覧情報を取得
	 * @param array $order
	 * @return unknown[]
	 */
	public function getListBySearch($order=[]){
		return $this->getBySearch("ItemList",$order);
	}
}