<?php
/**
 * [View]template/basicformtemplate：基本入力フォームテンプレート
 * 実行ボタンを上下に置いた入力フォームHTMLを出力
 *
 * @param $conName ：fwcore/Config/inputのフォーム名（必須）
 * @param $iData ：初期表示用データ（任意）
 * @param $btnname ：ボタン表示名（任意）
 * @link http://komaphp.k-akimoto-matsu.net/Manual#subtitle8 マニュアル@ビュー.template/inputtemplate
 * @author TakanoriMatsushige < http://k-akimoto-matsu.net/Inquiry >
 * @copyright k_akimoto_matsu. All Rights Reserved
 */
if(!isset($btnname) || is_null($btnname)){
	$btnname = "実行";
}
$formitem = require __DIR__.'/../template/inputtemplate.php';
$btn1 =  Form::submit("post1",$btnname,["class"=>"btn"]);
$btn2 =  Form::submit("post2",$btnname,["class"=>"btn"]);
$formhtml =<<< EOF
<form method="post" id="InputForm" action="{$_SERVER["REQUEST_URI"]}" enctype="multipart/form-data">
{$btn1}
<div class="spacer10"></div>
<span class="error">※</span>は必須
<hr>
<div class="spacer10"></div>
{$formitem}
{$btn2}
</form>
EOF;

return $formhtml;

