<?php
/**
 * [View]template/inputtemplate：入力フォームテンプレート
 * 入力フォームHTMLを出力（実行ボタンなし）
 *
 * @param $conName ：fwcore/Config/inputのフォーム名（必須）
 * @param $iData ：初期表示用データ（任意）
 * @link http://komaphp.k-akimoto-matsu.net/Manual#subtitle8 マニュアル@ビュー.template/inputtemplate
 * @author TakanoriMatsushige < http://k-akimoto-matsu.net/Inquiry >
 * @copyright k_akimoto_matsu. All Rights Reserved
 */
$inputconfig = Config::get("input",$conName);

if(is_null($inputconfig)){
	return null;
}
$html=null;

$er = false;

if(Helper::ak("error",$param)){
	$er = true;
}
if(!isset($inputCss)){
	$inputCss = null;
}

//初期表示ありなし　trueの場合はリストを初期表示しない
if(!isset($initialDisplay)){
	$initialDisplay = true;
}

//初期表示情報
//DBデータなど初期情報がある場合は呼び元から$iDateにデータを入れておくこと

//POST送信されていればそちらを優先
$dFlg = false;
if(!isset($iData)){
	$iData = [];
}else{
	$dFlg = true;
}
$inputdata = Input::all();
if(count($inputdata) > 0){
	$iData = $inputdata;
}

/*共通エラー*/
if(Helper::ak("error",$param) && Helper::ak("common",$param["error"])){
	$html.="<br /><span class=\"error\">".join("<br />",$param["error"]["common"])."</span><br />\n";
}

$html .= "<table id=\"{$conName}Form\" class=\"inputForm {$inputCss}\">\n";
foreach($inputconfig as $k=>$v){

	//表示しない指定がある場合はスルー
	//編集時のみ
	if(isset($action) && $action == "Edit"){
		if(Helper::ak("nodisp",$v)){
			$nod = explode("=",$v["nodisp"]);
			$nod_auth = explode(",",$nod[1]);
			$fnod_auth = array_flip($nod_auth);
			if(Helper::ak($nod[0],$iData) && isset($fnod_auth[$iData[$nod[0]]])){
				continue;
			}
		}
	}

	//隠し要素のときは表示しない
	if($v["type"] != "hidden"){
		$html .= "\t<tr>\n";
		$html .= "\t\t<th>\n";
		$rq = "";
		if(Helper::ak("requierd", $v) && $v["requierd"]){
			$rq  = "<span class=\"error\">※</span>";
		}
		$html .= "\t\t{$v["label"]}{$rq}\n";
		$html .= "\t\t</th>\n";
		$html .= "\t\t<td>\n";
	}
	$value = null;

	//初期値設定
	if(Helper::ak("default", $v)){
		$value = $v["default"];
	}

	//表示のみ
	$disp = false;
	if(Helper::ak("disp", $v)){
		$disp = $v["disp"];
	}

	switch($v["type"]){
		case "text":
		case "password":
		case "label":
		case "textarea":
		case "hidden":
			if(Helper::ak($v["name"], $iData)){
				$value = $iData[$v["name"]];
			}
			//表示フォーマットあれば
			if(Helper::ak("format", $v)){
				if(!is_null($value) && $value != "" && $value != "-"){
					$f = explode("-",$v["format"]);
					switch($f[0]){
						case "date":
							if(!isset($f[1])){
								$format = "Y/m/d";
							}else{
								$format = $f[1];
							}
							$value = date($f[1],strtotime($value));
							break;
						case "number":
							$value = number_format($value);
							break;
						case "money":
							if(!isset($f[1])){
								$format = "%i";
							}else{
								$format = $f[1];
							}
							$value = money_format($f[1],$value);
							break;
					}
				}
			}
			//強制固定値
			if(Helper::ak("fxvalue",$v)){
				$value = $v["fxvalue"];
			}

			$html .= Form::$v["type"]($v["name"],$value,$v["setting"]);
			break;
		case "date":
			if(Helper::ak($v["name"], $iData)){
				$value = $iData[$v["name"]];
			}
			if(!is_null($value) && trim($value) != "" && !$er){
				if(Helper::ak("format", $v)){
					$value = date($v["format"],strtotime($value));
				}
			}
			//強制固定値
			if(Helper::ak("fxvalue",$v)){
				$value = $v["fxvalue"];
			}
			$html .= Form::text($v["name"],$value,["readonly"=>"readonly","class"=>"read","style"=>"width:90px;"]);
			break;
		case "datetime":
			if(Helper::ak($v["name"], $iData)){
				$value = $iData[$v["name"]];
			}
			$value1=null;
			if(Helper::ak($v["name"]."Date", $iData)){
				$value1 = $iData[$v["name"]."Date"];
			}
			$value2=null;
			if(Helper::ak($v["name"]."Time", $iData)){
				$value2 = $iData[$v["name"]."Time"];
			}

			if(!is_null($value1) && !is_null($value2)){
				$value = $value1." ".$value2;
			}

			if(!is_null($value) && trim($value) != "" && !$er){
				$value1 = date("Y/m/d",strtotime($value));
				$value2 = date("H:i",strtotime($value));
			}else{
				$value1 = $value1;
				$value2 = $value2;
			}

			$html .= Form::text($v["name"]."Date",$value1,["readonly"=>"readonly","class"=>"read","style"=>"width:90px;"]);
			$html .= Form::text($v["name"]."Time",$value2,["style"=>"width:60px;"]);
			break;
		case "dateft":
			$fromname = $v["name"]."From";
			$toname = $v["name"]."To";

			if(Helper::ak($fromname, $iData)){
				$value = $iData[$fromname];
			}
			if(!is_null($value) && trim($value) != "" && !$er){
				if(Helper::ak("format", $v)){
					$value = date($v["format"],strtotime($value));
				}
			}
			if(is_null($value) && Helper::ak("init",$v)){
				$ini = explode("|",$v["init"]);
				if(isset(${$ini[0]})){
					$value = date($ini[1],strtotime(${$ini[0]}));
				}
			}
			$valueto = null;
			if(Helper::ak($toname, $iData)){
				$valueto = $iData[$toname];
			}
			if(!is_null($valueto) && trim($valueto) != "" && !$er){
				if(Helper::ak("format", $v)){
					$valueto = date($v["format"],strtotime($valueto));
				}
			}
			if(is_null($valueto) && Helper::ak("init",$v)){
				$ini = explode("|",$v["init"]);
				if(isset(${$ini[0]})){
					$valueto = date($ini[1],strtotime(${$ini[0]}));
				}
			}
			$set = array_merge($v["setting"],["style"=>"width:120px;"]);

			if(Helper::ak("readonly",$v) && $v["readonly"]){
				$set = array_merge($set,["readonly"=>"readonly","class"=>"read"]);
			}

			$html .= Form::text($fromname,$value,$set,$disp);
			$html .= "～".Form::text($toname,$valueto,$set,$disp);
			break;
		case "hift":
			$fromname = $v["name"]."From";
			$toname = $v["name"]."To";

			$valuef = null;
			$valuet = null;
			if(Helper::ak($fromname, $iData)){
				$valuef = $iData[$fromname];
			}
			if(Helper::ak($toname, $iData)){
				$valuet = $iData[$toname];
			}
			$set = array_merge($v["setting"],["style"=>"width:120px;"]);

			if(Helper::ak("readonly",$v) && $v["readonly"]){
				$set = array_merge($set,["readonly"=>"readonly","class"=>"read"]);
			}
			$html .= Form::text($fromname,$valuef,$set,$disp);
			$html .= "～".Form::text($toname,$valuet,$set,$disp);

			if(!$disp){
				//入力サポートありの場合
				if(Helper::ak("hisupport",$v) && $v["hisupport"]){
					$html .= <<<html
<script>
$(function(){
	$("#{$fromname}").focusin(function(e){
		hiselect("{$fromname}",$(this).val());
	});
	$("#{$fromname}").change(function(e){
		hiselect("{$fromname}",$(this).val());
	});
	$("#{$toname}").focusin(function(e){
		hiselect("{$toname}",$(this).val());
	});
	$("#{$toname}").change(function(e){
		hiselect("{$toname}",$(this).val());
	});
});
</script>
html;
				}
			}
			break;
		case "file":
			$movfilename = null;
			$upFileName = null;
			if(Helper::ak($v["name"], $iData)){
				$value = $iData[$v["name"]];
			}

			//エラーのときは前の画像を表示
			if($er){
				if(count($param["iData"]) > 0 && Helper::ak($v["name"], $param["iData"])){
					$value = $param["iData"][$v["name"]];
				}
			}

			//ファイルタイプがあれば送信
			if(Helper::ak("FileType",$param["iData"])){
				$v["setting"] = array_merge($v["setting"],["FileType"=>$param["iData"]["FileType"]]);
			}

			$upFileName = null;
			$base = "";
			if(Helper::ak("base_dir",$v)){
				$base =  $v["base_dir"];
			}
			//編集モード時は画像を表示
			if($action == "Edit"){
				//upfilename指定があれば対応する
				if(Helper::ak("upfilename",$v)){
					$upFileName = $v["upfilename"];
					preg_match_all("/\#.+?\#/",$upFileName,$matches);
					if($matches[0] > 0){
						foreach($matches[0] as $kvalue){
							$kv = str_replace("#","",$kvalue);
							if(Helper::ak($kv,$param["iData"])){
								$upFileName = str_replace($kvalue,$param["iData"][$kv],$upFileName);
							}
						}
					}

					if(Helper::ak("FileType",$param["iData"]) && $param["iData"]["FileType"] == "mov"){
						//動画ならこちらを優先
						if(Helper::ak("movpath",$v)){
							$movfilename = $v["movpath"];
							preg_match_all("/\#.+?\#/",$movfilename,$matches);
							if($matches[0] > 0){
								foreach($matches[0] as $kvalue){
									$kv = str_replace("#","",$kvalue);
									if(Helper::ak($kv,$param["iData"])){
										$movfilename = str_replace($kvalue,$param["iData"][$kv],$movfilename);
									}
								}
							}
						}
					}
				}else{
					$upFileName = $value;
				}
			}

			$html .= Form::file($v["name"],$upFileName,$v["setting"],$disp,$base,$vm,$movfilename);
			break;
		case "select":
		case "radio":
		case "check":
			if(Helper::ak($v["name"], $iData)){
				$value = $iData[$v["name"]];
				if($v["type"] == "check" && $dFlg && !is_array($value)){
					$value = explode("|",$value);
				}
			}elseif(!Helper::ak($v["name"], $iData) && $v["type"] == "check"){
				//$value = [];
			}
			$type = [];
			if(Helper::ak("select", $v)){
				$type = Config::get("type",$v["select"]);
				if(!is_null($type)){
					$html .= Form::$v["type"]($v["name"],$type,$value,$v["setting"]);
				}else{
					//ない場合はDBから持ってくるケース
					$pt = explode(":",$v["select"]);
					if($pt[0] == "DB"){
						if(isset($pt[1]) && isset($pt[2])){
							$ptt = explode("-",$pt[1]);
							$table = $ptt[0];
							$w=[];
							if(isset($ptt[1])){
								$pttt = explode("=",$ptt[1]);
								$w = [$pttt[0]=>$pttt[1]];
							}
							$mo = DbModel::read($table);
							$datas = $mo->getList($w);
							$type=[];
							$getAr = explode("=",$pt[2]);
							foreach($datas as $key=>$va){
								$type[$va[$getAr[0]]] = $va[$getAr[1]];
							}
							$html .= Form::$v["type"]($v["name"],$type,$value,$v["setting"]);
						}
					}
				}
			//from～toで数字的な期間を初期値とするパターン
			}elseif(Helper::ak("term", $v)){
				$tm = explode("-",$v["term"]);
				if(count($tm) == 2){
					for($ti = $tm[0];$ti<=$tm[1];$ti++){
						$type[$ti] = $ti;
					}
				}

				$html .= Form::$v["type"]($v["name"],$type,$value,$v["setting"]);
			}
	}
	//連動する子要素がある場合
	if(Helper::ak("child",$v) && $v["child"]){
		//空要素を置くのみ
		$subvalue = null;
		switch($v["subtype"]){

			case "text":
			case "password":
			case "label":
			case "textarea":
			case "hidden":
				if(Helper::ak($v["subname"], $iData)){
					$subvalue = $iData[$v["subname"]];
				}
				$html .= Form::$v["type"]($v["subname"],$subvalue,$v["subsetting"],$disp);
				break;
			case "select":
			case "radio":
			case "check":
				if(Helper::ak($v["subname"], $iData)){
					$subvalue = $iData[$v["subname"]];
					if($v["subtype"] == "check" && $dFlg && !is_array($value)){
						$value = explode("|",$value);
					}
				}elseif(!Helper::ak($v["subname"], $iData) && $v["type"] == "check"){
					$subvalue = [];
				}
				$type = [];
				//親が空なら何もない情報を表示：radio,check時は別途処理が必要
				if(is_null($value)){
					$subform = Form::$v["subtype"]($v["subname"],$type,$subvalue,$v["subsetting"]);
				}else{
					if(Helper::ak("subselect", $v)){
						$type = Config::get("type",$v["subselect"]);
						if(!is_null($type)){
							$subform .= Form::$v["subtype"]($v["subname"],$type,$subvalue,$v["subsetting"]);
						}else{
							//ない場合はDBから持ってくるケース
							$pt = explode(":",$v["subselect"]);
							if($pt[0] == "DB"){
								if(isset($pt[1]) && isset($pt[2])){
									$ptt = explode("-",$pt[1]);
									$table = $ptt[0];
									$w=[];
									if(isset($ptt[1])){
										$pttt = explode("=",$ptt[1]);
										$w = [$pttt[0]=>$pttt[1]];
									}
									//絞込み条件に親コード
									$w[$v["name"]] = $value;
									$mo = DbModel::read($table);
									if(!is_null($mo)){
										$datas = $mo->getList($w);
									}else{
										$datas = [];
									}
									$getAr = explode("=",$pt[2]);
									foreach($datas as $key=>$va){
										$type[$va[$getAr[0]]] = $va[$getAr[1]];
									}
									$dv = false;
									if(Helper::ak("disp_key",$v)){
										$dv = $v["disp_key"];
									}
									$subform = Form::$v["subtype"]($v["subname"],$type,$subvalue,$v["subsetting"],$disp,$dv);
								}
							}
						}
					//from～toで数字的な期間を初期値とするパターン
					}elseif(Helper::ak("subterm", $v)){
						$tm = explode("-",$v["subterm"]);
						if(count($tm) == 2){
							for($ti = $tm[0];$ti<=$tm[1];$ti++){
								$type[$ti] = $ti;
							}
						}

						$subform = Form::$v["subtype"]($v["subname"],$type,$subvalue,$v["subsetting"],$disp,$dv);
					}
				}
				break;
		}

		$rq = "";
		if(Helper::ak("subrequierd", $v) && $v["subrequierd"]){
			$rq  = "<span class=\"error\">※</span>";
		}
		$html .= <<<EOF
		&nbsp;&nbsp;
		<span id="sublabel_{$v["subname"]}">{$v["sublabel"]}{$rq}</span>&nbsp;<span id="subform_{$v["subname"]}">{$subform}</span>
		</span>
EOF;
	}
	//隠し要素のときは表示しない
	if($v["type"] != "hidden"){
		//エラー表示
		if(Helper::ak("help", $v)){
			$html .= "<span class=\"help\">{$v["help"]}</span>";
		}
		if($er){
			if(Helper::ak($v["name"], $param["error"])){
				$html.="<br /><span class=\"error\">".join("<br />",$param["error"][$v["name"]])."</span>";
			}
		}

		//追加機能：ボタン
		if(Helper::ak("button", $v)){
			//渡すパラメータ
			$nParam = [];
			foreach($v["button"] as $n=>$vv){
				if( $n <= 2) continue;
				$nParam[]  = "'".$vv."'";

			}
			$html .= "<p>".Form::button($v["name"].$v["button"][0],$v["button"][1],["onClick"=>"{$v["button"][2]}('".Config::get("app","httproot")."',".join(",",$nParam).");","class"=>"innerButton"])."</p>";
		}

		$html .= "\t\t</td>\n";
		$html .= "\t</tr>\n";
	}
}
$html .= "</table>";
$html .= "<div class=\"spacer10\"></div>";

return $html;

