<?php
/**
 * [View]template/searchtemplate：検索フォームテンプレート
 * 検索フォームHTMLを出力
 *
 * @param $conName ：fwcore/Config/searchのフォーム名（必須）
 * @param Session::get({フォーム名}) ：検索条件データ（任意）：ControllerのPOSTにSession::get({フォーム名})にInput::all()を設定する
 * @link http://komaphp.k-akimoto-matsu.net/Manual#subtitle8 マニュアル@ビュー.template/searchtemplate
 * @author TakanoriMatsushige < http://k-akimoto-matsu.net/Inquiry >
 * @copyright k_akimoto_matsu. All Rights Reserved
 */
$inputconfig = Config::get("search",$conName);

if(is_null($inputconfig)){
	return null;
}
$html=null;

$er = false;

if(Helper::ak("error",$param)){
	$er = true;
}
if(!isset($inputCss)){
	$inputCss = null;
}
if(!isset($csvexport)){
	$csvexport = false;
}

//初期表示情報
$iData = Session::get($conName);
//初期表示ありなし　trueの場合はリストを初期表示しない
if(!isset($initialDisplay)){
	$initialDisplay = true;
}

//POST送信されていればそちらを優先
$dFlg = false;
if(!isset($iData)){
	$iData = [];
}else{
	$dFlg = true;
}
$inputdata = Input::all();
if(count($inputdata) > 0){
	$iData = $inputdata;
}

//検索条件は常に出しっぱなし
$html .= "<div id=\"searchOpen\" OnClick=\"areaToggle('search',1);\" class=\"searchArea\" style=\"display:none;\">▼検索条件を開く</div>\n";
$html .= "<div id=\"searchClose\" OnClick=\"areaToggle('search',0);\" class=\"searchArea\">▲検索条件を閉じる</div>\n";
$html .= "<div id=\"searchArea\">\n";

$html .= "<form method=\"post\" id=\"searchForm\" action=\"".Config::get("app","httproot").$conName."\">\n";
$html .= "<table id=\"{$conName}SearchForm\" class=\"inputForm {$inputCss}\">\n";
$rqList = [];
foreach($inputconfig as $k=>$v){
	//隠し要素のときは表示しない
	if($v["type"] != "hidden"){
		$html .= "\t<tr>\n";
		$html .= "\t\t<th>\n";
		$rq = "";
		if(Helper::ak("requierd", $v) && $v["requierd"]){
			$rq  = "<span class=\"error\">※</span>";
			$rqList[] = "{$v["label"]}={$v["name"]}";
		}
		$html .= "\t\t{$v["label"]}{$rq}\n";
		$html .= "\t\t</th>\n";
		$html .= "\t\t<td>\n";
	}
	$value = null;

	//初期値設定
	if(Helper::ak("default", $v)){
		$value = $v["default"];
	}

	//表示のみ
	$disp = false;
	if(Helper::ak("disp", $v)){
		$disp = $v["disp"];
	}
	switch($v["type"]){
		case "text":
		case "password":
		case "label":
		case "textarea":
		case "hidden":
			if(Helper::ak($v["name"], $iData)){
				$value = $iData[$v["name"]];
			}
			//表示フォーマットあれば
			if(Helper::ak("format", $v)){
				if(!is_null($value) && $value != "" && $value != "-"){
					$f = explode("-",$v["format"]);
					switch($f[0]){
						case "date":
							if(!isset($f[1])){
								$format = "Y/m/d";
							}else{
								$format = $f[1];
							}
							$value = date($f[1],strtotime($value));
							break;
						case "number":
							$value = number_format($value);
							break;
						case "money":
							if(!isset($f[1])){
								$format = "%i";
							}else{
								$format = $f[1];
							}
							$value = money_format($f[1],$value);
							break;
					}
				}
			}
			$html .= Form::$v["type"]($v["name"],$value,$v["setting"],$disp);
			break;
		case "date":
			if(Helper::ak($v["name"], $iData)){
				$value = $iData[$v["name"]];
			}
			if(!is_null($value) && trim($value) != "" && !$er){
				if(Helper::ak("format", $v)){
					$value = date($v["format"],strtotime($value));
				}
			}
			$html .= Form::text($v["name"],$value,["readonly"=>"readonly","class"=>"read","style"=>"width:90px;"],$disp);

			break;
		case "datetime":
			if(Helper::ak($v["name"], $iData)){
				$value = $iData[$v["name"]];
			}
			$value1=null;
			if(Helper::ak($v["name"]."Date", $iData)){
				$value1 = $iData[$v["name"]."Date"];
			}
			$value2=null;
			if(Helper::ak($v["name"]."Time", $iData)){
				$value2 = $iData[$v["name"]."Time"];
			}

			if(!is_null($value1) && !is_null($value2)){
				$value = $value1." ".$value2;
			}

			if(!is_null($value) && trim($value) != "" && !$er){
				$value1 = date("Y/m/d",strtotime($value));
				$value2 = date("H:i",strtotime($value));
			}else{
				$value1 = $value1;
				$value2 = $value2;
			}

			$html .= Form::text($v["name"]."Date",$value1,["readonly"=>"readonly","class"=>"read","style"=>"width:90px;"],$disp);
			$html .= Form::text($v["name"]."Time",$value2,["style"=>"width:60px;"],$disp);

			break;
		case "select":
		case "radio":
		case "check":
			if(Helper::ak($v["name"], $iData)){
				$value = $iData[$v["name"]];
				if($v["type"] == "check" && $dFlg && !is_array($value)){
					$value = explode("|",$value);
				}
			}elseif(!Helper::ak($v["name"], $iData) && $v["type"] == "check"){
				$value = [];
			}
			$type = [];
			if(Helper::ak("select", $v)){
				$type = Config::get("type",$v["select"]);
				if(!is_null($type)){
					$html .= Form::$v["type"]($v["name"],$type,$value,$v["setting"]);
				}else{
					//ない場合はDBから持ってくるケース
					$pt = explode(":",$v["select"]);
					if($pt[0] == "DB"){
						if(isset($pt[1]) && isset($pt[2])){
							$ptt = explode("-",$pt[1]);
							$table = $ptt[0];
							$w=[];
							if(isset($ptt[1])){
								$pttt = explode("=",$ptt[1]);
								$w = [$pttt[0]=>$pttt[1]];
							}
							$mo = DbModel::read($table);
							if(!is_null($mo)){
								$datas = $mo->getList($w);
							}else{
								$datas = [];
							}
							$type=[];
							$getAr = explode("=",$pt[2]);
							foreach($datas as $key=>$va){
								$type[$va[$getAr[0]]] = $va[$getAr[1]];
							}
							$dv = false;
							if(Helper::ak("disp_key",$v)){
								$dv = $v["disp_key"];
							}
							$html .= Form::$v["type"]($v["name"],$type,$value,$v["setting"],$disp,$dv);
						}
					}
				}
			}elseif(Helper::ak("term", $v)){
				$tm = explode("-",$v["term"]);
				if(count($tm) == 2){
					for($ti = $tm[0];$ti<=$tm[1];$ti++){
						$type[$ti] = $ti;
					}
				}

				$html .= Form::$v["type"]($v["name"],$type,$value,$v["setting"]);
			}
			break;
	}

	//連動する子要素がある場合
	if(Helper::ak("child",$v) && $v["child"]){
		//空要素を置くのみ
		$subvalue = null;
		switch($v["subtype"]){

			case "text":
			case "password":
			case "label":
			case "textarea":
			case "hidden":
				if(Helper::ak($v["subname"], $iData)){
					$subvalue = $iData[$v["subname"]];
				}
				$html .= Form::$v["type"]($v["subname"],$subvalue,$v["subsetting"],$disp);
				break;
			case "select":
			case "radio":
			case "check":
				if(Helper::ak($v["subname"], $iData)){
					$subvalue = $iData[$v["subname"]];
					if($v["subtype"] == "check" && $dFlg && !is_array($value)){
						$value = explode("|",$value);
					}
				}elseif(!Helper::ak($v["subname"], $iData) && $v["type"] == "check"){
					$subvalue = [];
				}
				$type = [];
				//親が空なら何もない情報を表示：radio,check時は別途処理が必要
				if(is_null($value)){
					$subform = Form::$v["subtype"]($v["subname"],$type,$subvalue,$v["subsetting"]);
				}else{
					if(Helper::ak("subselect", $v)){
						$type = Config::get("type",$v["subselect"]);
						if(!is_null($type)){
							$subform .= Form::$v["subtype"]($v["subname"],$type,$subvalue,$v["subsetting"]);
						}else{
							//ない場合はDBから持ってくるケース
							$pt = explode(":",$v["subselect"]);
							if($pt[0] == "DB"){
								if(isset($pt[1]) && isset($pt[2])){
									$ptt = explode("-",$pt[1]);
									$table = $ptt[0];
									$w=[];
									if(isset($ptt[1])){
										$pttt = explode("=",$ptt[1]);
										$w = [$pttt[0]=>$pttt[1]];
									}
									//絞込み条件に親コード
									$w[$v["name"]] = $value;
									$mo = DbModel::read($table);
									if(!is_null($mo)){
										$datas = $mo->getList($w);
									}else{
										$datas = [];
									}
									$getAr = explode("=",$pt[2]);
									foreach($datas as $key=>$va){
										$type[$va[$getAr[0]]] = $va[$getAr[1]];
									}
									$dv = false;
									if(Helper::ak("disp_key",$v)){
										$dv = $v["disp_key"];
									}
									$subform = Form::$v["subtype"]($v["subname"],$type,$subvalue,$v["subsetting"],$disp,$dv);
								}
							}
						}
					}
				}
				break;
		}

		$rq = "";
		if(Helper::ak("subrequierd", $v) && $v["subrequierd"]){
			$rq  = "<span class=\"error\">※</span>";
			$rqList[] = "{$v["sublabel"]}={$v["subname"]}";
		}
		$html .= <<<EOF
		&nbsp;&nbsp;
		<span id="sublabel_{$v["subname"]}">{$v["sublabel"]}{$rq}</span>&nbsp;<span id="subform_{$v["subname"]}">{$subform}</span>
		</span>
EOF;
	}

	//隠し要素のときは表示しない
	if($v["type"] != "hidden"){
		//エラー表示
		if(Helper::ak("help", $v)){
			$html .= "<span class=\"help\">{$v["help"]}</span>";
		}
		if($er){
			if(Helper::ak($v["name"], $param["error"])){
				$html.="<br /><span class=\"error\">".join("<br />",$param["error"][$v["name"]])."</span>";
			}
		}

		//追加機能：ボタン
		if(Helper::ak("button", $v)){
			//
			//渡すパラメータ
			$nParam = [];
			foreach($v["button"] as $n=>$vv){
				if( $n <= 2) continue;
				$nParam[]  = "'".$vv."'";

			}
			$html .= "<p>".Form::button($v["name"].$v["button"][0],$v["button"][1],["onClick"=>"{$v["button"][2]}('".Config::get("app","httproot")."',".join(",",$nParam).");","class"=>"innerButton"])."</p>";
		}

		$html .= "\t\t</td>\n";
		$html .= "\t</tr>\n";
	}
}
$html .= "</table>\n";

$rqflg = "0";
$targetField = "";
if(count($rqList) > 0){
	$rqflg = "1";
	$targetField = join("|",$rqList);
}


$html.= '<div class="fullblock bcenter">';
$html.= '<div class="spacer10"></div>';
$html.= Form::submit($conName."Search","検索",["onClick"=>"searchAction('{$rqflg}','{$targetField}');return false;", "class"=>"center width-100px"]);
$html.= '</div>';

$html .= "</form>\n";

$html .= "</div>\n";
$html .= "<div class=\"spacer10\"></div>\n";
return $html;

