<?php
/**
 * [View]template/template：管理画面用等HTML出力テンプレート
 *
 * @param $contents ：メインコンテンツ部分（必須）
 * @param $title ：記事タイトル（任意） なにもしなければコントローラで設定した$param->tileがセットされる
 * @param $subtitle ：記事サブタイトル（任意）
 * @param $breadcrumbs ：パンくず（任意）
 * @link http://komaphp.k-akimoto-matsu.net/Manual#subtitle8 マニュアル@ビュー.template/template
 * @author TakanoriMatsushige < http://k-akimoto-matsu.net/Inquiry >
 * @copyright k_akimoto_matsu. All Rights Reserved
 */
$root = Config::get("app","adminroot");
$htproot = Config::get("app","httproot");
$logoutaction =null;

//ログイン時のみ表示するもの
if(!is_null(Session::get("login")) && Session::get("login")){
	$logoutaction = <<< EOF
<script>
function dologout(){
	if(confirm("ログアウトしますか？")){
		$("#logoutaction").submit();
		return true;
	}else{
		return false;
	}
}
</script>

EOF;

}

//戻り先
$bk = "";
if(isset($back)){
	$bk = Html::link($back,"戻る",["title"=>"戻る","id"=>"back"]);
}
if(!isset($title)){
	$title =null;
}
if(!isset($subtitle)){
	$subtitle =null;
}

//システムバージョン
$nev = time();

//当年
$yn = date("Y");

//パンくず設定あれば
$breadcrumbs = null;
if(isset($bread)){
	$breadlist = null;

	//lastが設定されていない場合は最後のキーを対象とする
	if(!isset($bread_last)){
		end($bread);
		$array_last_info = each($bread);
		$bread_last = $array_last_info["key"];

	}
	foreach($bread as $con_url=>$listName){
		$last = null;

		if(isset($bread_last) && $bread_last == $con_url){
			$last = "last";
	    }

		$breadlist .= "<a href=\"#!\" class=\"bread {$last}\">{$listName}</a>";
	}
	$breadcrumbs = <<<EOF
<div class="spacer15"></div>
<div id="breadcrumbs">
{$breadlist}
</div>
EOF;
}

$ow = Config::get("ow","ownerweb");

echo <<< HTML
<!DOCTYPE html>
<html>
<head>
<meta charset="utf-8">
<meta name="robots" content="noindex,nofollow89">
<title>[管理画面]{$sysname}-{$title}-</title>
<script src="{$htproot}js/jq/jquery.js?v={$nev}"></script>
<script src="{$root}js/main.js?v={$nev}"></script>
<link rel="stylesheet" type="text/css" href="{$root}css/main.css?v={$nev}">
</head>
<div id="main">
	{$breadcrumbs}
	<h1>{$sysname}</h1>
	<div id="contentsBody">
		{$bk}
		<h2>{$title}{$subtitle}</h2>
		{$contents}
		<div class="spacer10"></div>
	</div>
</div>
<footer>
&copy; 2010-{$yn} <a href="{$ow}" target="_blank">k_akimoto_matsu</a>. All Rights Reserved.
</footer>
{$logoutaction}
</body>
</html>
HTML;
